SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'books catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:24'!
addBook: aBook 
	books addBook: aBook! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:26'!
withCatalog: aCatalog 
	^self new catalog: aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:27'!
addBook: aBook 
	(catalog includesBook: aBook) ifTrue: [ books add: aBook]! !

!Cart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:22'!
catalog: aCatalog 
	catalog := aCatalog.
	books := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:09'!
isEmpty
	 ^books isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:11'!
listCart
	 ^books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:40'!
size
	^books size! !

Object subclass: #Catalog
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Catalog methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:30'!
addBook: aBook 
	books add: aBook! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:28'!
includesBook: aBook
	^books includes: aBook! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:44'!
initialize 
	super initialize.
	books := Set new.! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:43'!
size
	^books size! !

TestCase subclass: #TestCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:36'!
test01CartShouldBeEmptyWhenCreated
	|catalog cart|
	catalog := Catalog new.
	cart := Cart withCatalog: catalog.
	self assert: cart isEmpty! !

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:49'!
test02CartShouldListBooksWhenABookIsAdded
	|catalog cart book|
	book := 'Lord of the Rings'.
	catalog := Catalog new.
	catalog addBook: book.
	cart := Cart withCatalog: catalog.
	cart addBook: book.
	self assert: (cart listCart includes: book).! !

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:37'!
test03ABookShouldNotBeAddedToCartIfItIsNotInTheCatalog
	|cart catalog book|
	catalog := Catalog new.
	cart := Cart withCatalog: catalog.
	book := 'Lord of the Rings'.
	cart addBook: book.
	self deny: (cart listCart includes: book)
	! !

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:41'!
test04AddABookMultipleTimesMakesTheCartSizeToIncrease
	|cart catalog book|
	book := 'Lord of the Rings'.
	catalog := Catalog new.
	catalog addBook: book.
	cart := Cart withCatalog: catalog.	
	cart addBook: book; addBook: book.
	self assert: (cart size = 2)
	! !

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:43'!
test05AddABookToCatalogThatAlreadyExistsDoesNotAddItTwice
	|catalog book|
	book := 'Lord of the Rings'.
	catalog := Catalog new.
	catalog addBook: book; addBook: book.
	self assert: catalog size = 1.	! !

!TestCart methodsFor: 'as yet unclassified' stamp: 'achavez 5/27/2013 21:48'!
test06CartShouldListAllBooksWhenMultipleBooksAreAdded
	|lotr hobbit catalog cart|
	lotr := 'Lord of the Rings'.
	hobbit := 'The Hobbit'.
	catalog := Catalog new.
	catalog addBook: lotr; addBook: hobbit.
	cart := Cart withCatalog: catalog.
	cart addBook: lotr; addBook: hobbit.
	self assert: (cart listCart includes: lotr); 
		assert: (cart listCart includes: hobbit);
		assert: cart size = 2.! !
